/****************************************************
  Scan Address-bus test for C64xx

*****************************************************/

#define __C6X_SELECT_C64XX_DSP__	
#include "c6x_def.h"


init_cpu()
{
	*C6X_EMIFA_GCR=0x0009277c;
	*C6X_EMIFA_CE0=0xffffffc3;	// configure all EMIF-A areas as 64-BIT ASYNC
	*C6X_EMIFA_CE1=0xffffffc3;
	*C6X_EMIFA_CE2=0xffffffc3;
	*C6X_EMIFA_CE3=0xffffffc3;


	*C6X_EMIFB_GCR=0x0009277c;
	*C6X_EMIFB_CE0=0xffffff13;	// configure all EMIF-B areas as 16-BIT ASYNC
	*C6X_EMIFB_CE1=0xffffff13;
	*C6X_EMIFB_CE2=0xffffff13;
	*C6X_EMIFB_CE3=0xffffff13;

}


main()
{
   unsigned d;
   unsigned short x;

   init_cpu();

 while(1)
 {
	// provide EMIF-A EA3 SYNCHRO as triple-width

	// scan address obver EMIF-A CE-0 area initialy
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+8));
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+8));
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+8)); 

   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+0x10)); /*EA4 */
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+0x20)); /*EA5 */
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+0x40)); /*EA6 */
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+0x80)); /*EA7 */
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+0x100)); /*EA8 */
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+0x200)); /*EA9 */
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+0x400)); /*EA10 */
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+0x800)); /*EA11 */
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+0x1000)); /*EA12 */
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+0x2000)); /*EA13 */
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+0x4000)); /*EA14 */
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+0x8000)); /*EA15 */
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+0x10000)); /*EA16 */
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+0x20000)); /*EA17 */
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+0x40000)); /*EA18 */
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+0x80000)); /*EA19 */

   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+0x100000)); /*EA20 */
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+0x200000)); /*EA21 */
   d=*((unsigned *) (C64XX_EMIFA_CE0_AREA_SADDR+0x400000)); /*EA22 */

   *((char *) (C64XX_EMIFA_CE0_AREA_SADDR+0)) = 1;   		// test for BE-0..7 strobes
   *((char *) (C64XX_EMIFA_CE0_AREA_SADDR+1)) = 2; 
   *((char *) (C64XX_EMIFA_CE0_AREA_SADDR+2)) = 4; 
   *((char *) (C64XX_EMIFA_CE0_AREA_SADDR+3)) = 8; 
   *((char *) (C64XX_EMIFA_CE0_AREA_SADDR+4)) = 0x10; 
   *((char *) (C64XX_EMIFA_CE0_AREA_SADDR+5)) = 0x20; 
   *((char *) (C64XX_EMIFA_CE0_AREA_SADDR+6)) = 0x40; 
   *((char *) (C64XX_EMIFA_CE0_AREA_SADDR+7)) = 0x80; 


	// now scan address bits of EMIF-B CE-2 area (not used)
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+2)); 			// EA1
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+4)); 			// EA2
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+8)); 			// EA3
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+0x10)); 		/*EA4 */
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+0x20)); 		/*EA5 */
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+0x40)); 		/*EA6 */
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+0x80)); 		/*EA7 */
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+0x100)); 		/*EA8 */
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+0x200)); 		/*EA9 */
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+0x400)); 		/*EA10 */
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+0x800)); 		/*EA11 */
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+0x1000)); 	/*EA12 */
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+0x2000)); 	/*EA13 */
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+0x4000)); 	/*EA14 */
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+0x8000)); 	/*EA15 */
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+0x10000)); 	/*EA16 */
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+0x20000)); 	/*EA17 */
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+0x40000)); 	/*EA18 */
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+0x80000)); 	/*EA19 */
   x=*((unsigned short *) (C64XX_EMIFB_CE2_AREA_SADDR+0x100000)); 	/*EA20 */


   *((char *) (C64XX_EMIFB_CE2_AREA_SADDR+0)) = 1;   				// test for BE-0/1 strobes
   *((char *) (C64XX_EMIFB_CE2_AREA_SADDR+1)) = 2; 


 }

}


