/****************************************************
  Scan Data-bus test for C64x

*****************************************************/

#define __C6X_SELECT_C64XX_DSP__	

#include "c6x_def.h"


#define	EMIFA_DMEM_START_PTR		C64XX_EMIFA_CE0_AREA_SADDR
#define	EMIFB_DMEM_START_PTR		C64XX_EMIFB_CE2_AREA_SADDR

init_cpu()
{
	*C6X_EMIFA_GCR=0x0009277c;
	*C6X_EMIFA_CE0=0xffffffC3;	// configure all EMIF-A areas as 64-BIT ASYNC
	*C6X_EMIFA_CE1=0xffffffC3;
	*C6X_EMIFA_CE2=0xffffffC3;
	*C6X_EMIFA_CE3=0xffffffC3;


	*C6X_EMIFB_GCR=0x0009277c;
	*C6X_EMIFB_CE0=0xffffff13;	// configure all EMIF-B areas as 16-BIT ASYNC
	*C6X_EMIFB_CE1=0xffffff13;
	*C6X_EMIFB_CE2=0xffffff13;
	*C6X_EMIFB_CE3=0xffffff13;

}

main()
{
   	unsigned d, i;
   	unsigned short d_short;
	unsigned *ptr ;
	unsigned short *ptr_short ;


   	init_cpu();

   	while(1)
    {
	  ptr = (unsigned*) EMIFA_DMEM_START_PTR;
	  ptr_short = (unsigned short *) EMIFB_DMEM_START_PTR;

		// EMIF-A CE-0 data shift (bits 0..31)
      for(d=0x1L, i=0; i<32 ; i++)
		{ 
			*ptr = d;
		  	if(i==0) *ptr=d; // perform double width for D0 synchronization 
	  		d= (d<<1);
		}

	  *ptr = 0;

	 
		// EMIF-A CE-0 data shift (bits 32..63)
	  ptr++;
      for(d=0x1L, i=0; i<32 ; i++)
		{ 
			*ptr = d;
		  	if(i==0) *ptr=d; // perform double width for D0 synchronization 
	  		d= (d<<1);
		}

	  *ptr = 0;

		// EMIF-B CE-2 data shift
      for(d_short=0x1L, i=0; i<16 ; i++)
		{ 
			*ptr_short = d_short;
		  	if(i==0) *ptr_short=d_short; // perform double width for D0 synchronization
	  		d_short= (d_short<<1);
		}

	  *ptr_short = 0;
    }
}



